from typing import Generic, TypeVar

from rainbowadn.core import *
from .iauto import *

__all__ = ('IPair',)

E0 = TypeVar('E0')
E1 = TypeVar('E1')


class IPair(IAuto, Generic[E0, E1]):
    e0: HashPoint[E0]
    e1: HashPoint[E1]

    def __init__(self, *args):
        super().__init__(*args)
        self.e0, self.e1 = self.hashpoints()

    @classmethod
    async def off(cls, e0: HashPoint[E0], e1: HashPoint[E1]) -> 'IPair[E0, E1]':
        assert isinstance(e0, HashPoint)
        assert isinstance(e1, HashPoint)
        return await cls.auto_off(e0, e1)

    @classmethod
    def of(cls, v0: E0, v1: E1) -> 'IPair[E0, E1]':
        assert isinstance(v0, Mentionable)
        assert isinstance(v1, Mentionable)
        return cls.auto_of(v0, v1)

    @classmethod
    def f(cls, f0: RainbowFactory[E0], f1: RainbowFactory[E1]) -> RainbowFactory['IPair[E0, E1]']:
        assert isinstance(f0, RainbowFactory)
        assert isinstance(f1, RainbowFactory)
        return cls.auto_f(f0, f1)
